
#include <windows.h>
#include <stdio.h>
#include <lwserver.h>
#include <lwcmdseq.h>	// class:CommandSequence (lwdyna,lwtypes,lwmeshedt)
#include "lwlscript.h"	// get from  LW7.5D Package or 8.0 SDK.zip.

// ===============================================================
static LS_VAR result[2] = { 0,};	// for return(ptr)
static int isActive = 0;
// ===============================================================
// use .def file for export table. if use def & __decl(), table made twice.
//__declspec(dllexport) LS_VAR * queryFlags(int *count, LS_VAR *var, LSFunc *func)
LS_VAR * queryFlags(int *count, LS_VAR *var, LSFunc *func)
{	// Export to LScript.
	*(count) = 2;
	if(!isActive){
		result[0].type = LSNIL;		// selection
		result[1].type = LSNIL;		// symmetry
//		result[0].data.number = 0.0;	// if(LSNIL) dont refference number
//		result[1].data.number = 0.0;
	}
	isActive = 0;		// clear Activity
	return(result);
}

//------------------------------------------------------------------------------
BOOL APIENTRY DllMain(HINSTANCE hInst, DWORD reason, LPVOID reserved)
{ return(TRUE); }	// windows Rule.

// ===============================================================
static XCALL_(int) activate(int version, GlobalFunc *global, LWModCommand *local, void *serverData)
{	// Basic Modeler Plugin.
	LWStateQueryFuncs *query = global(LWSTATEQUERYFUNCS_GLOBAL, GFUSE_TRANSIENT);
	int sel = query->mode(LWM_MODE_SELECTION);	// 0:pnt 1:pol 2:vol 3:edg
	int sym = query->mode(LWM_MODE_SYMMETRY);	// 0:off 1:on
	result[0].type = LSINTEGER;
	result[1].type = LSINTEGER;
	result[0].data.number = (double)sel;
	result[1].data.number = (double)sym;

	isActive = 1;	// Active
	return(AFUNC_OK);
}

//------------------------------------------------------------------------------
static ServerTagInfo svTag[] = {
	{ "AStools", SRVTAG_CMDGROUP },
	{ NULL }
};

ServerRecord ServerDesc[] = {
	{ LWMODCOMMAND_CLASS, "LS_QueryFlags", (ActivateFunc *)activate, svTag },
	{ NULL }
};
